@echo off
%windir%\System32\more +8 "%~f0" > "%temp%\%~n0.ps1"
powershell -NoProfile -ExecutionPolicy Bypass -File "%temp%\%~n0.ps1" %*
del %temp%\%~n0.ps1
pause
exit /b

*** Ab hier PowerShell ***
#Requires -RunAsAdministrator
#Überprüfung, ob Powershell als Admin läuft. Wenn nicht wird das Script abgebrochen. Fehlermeldung ist eindeutig.

# First we create the request.
$HTTP_Request = [System.Net.WebRequest]::Create('http://ca.tergroup.com')
# We then get a response from the site.
$HTTP_Response = $HTTP_Request.GetResponse()
# We then get the HTTP code as an integer.
$HTTP_Status = [int]$HTTP_Response.StatusCode
If ($HTTP_Status -eq 200) {
    Write-Host 'Die Seite ca.tergroup.com ist online.'
}
Else {
    Write-Host 'Die Seite ca.tergroup.com könnte offline sein. Bitte überprüfen! Website ca.tergroup.com might be down. Please check if its online!'
    Start-Sleep -s 10 
    exit
}
# Finally, we clean up the http request by closing it.
If ($HTTP_Response -eq $null) { } 
Else { $HTTP_Response.Close() }

#Überprüfung, ob Ordner existiert. Wenn nicht wird er erstellt, weil sonst die Zertifikate nicht abgelegt werden können.
$i = 0
$Temp = "$env:temp\Tergroup_Certificates\"
if ((Test-Path $Temp) -eq $false){New-Item -ItemType Directory -Force -Path $Temp}




#region Vorheriger Ansatz
#Untersuche die Seite ca.tergroup.com nach Downloadlinks für Zertifikate und speichere sie in $results
#Achtung: Es wird immer die CA gewählt, die kein (*) enthalten
#Zertifikate müssen folgendes Format haben: certdata, http, rootca, ca2, ca3 
#$url = 'http://ca.tergroup.com'
#$results = (((Invoke-WebRequest -uri $url -UseBasicParsing).Links|
#Where-Object {$_.href -like '*http*rootCA*' -or $_.href -like '*http*ca2*' -or '*http*ca3*' -and $_.href -notlike '*(*)*' -and $_.href -like '*certdata*' -and $_.href -like '*.crt'} ) |
#select href).href
#endregion

#Links für die Zertifikate.
$results = @("http://ca.tergroup.com/certdata/CA1_TerHell_RootCA_Latest.crt", "http://ca.tergroup.com/certdata/CA2_TerHell_Latest.crt", "http://ca.tergroup.com/certdata/CA3_TerHell_Latest.crt")

#Formatiere die Links zu kompatible Dateinamen und lade die CAs herunter.
ForEach ($result in $results) {
    Write-Host $i
    Write-Host $result
    $Namen = $result -replace '[^a-zA-Z0-9-.]'
    [string]$Pfad = $Temp+$Namen
    Invoke-Webrequest -URI $result -OutFile $Pfad -UseBasicParsing
    $i++
    Write-Host $Pfad
    Write-Host $Namen
}


#Write-Color Funktion
function Write-Color([String[]]$Text, [ConsoleColor[]]$Color) {
    for ($i = 0; $i -lt $Text.Length; $i++) {
        Write-Host $Text[$i] -Foreground $Color[$i] -NoNewLine
    }
    Write-Host
}
#Example: Write-Colour -Text "STRING" -Color "FARBE"


#Zertifikate werden unterschieden zwischen: ROOTCA, CA2 und CA3!

#Suche die RootCAs und importiere sie 
$RootCA = Get-ChildItem -Path $Temp | where-Object {$_.Name -like '*http*rootCA*'}

ForEach ($CA in $RootCA) {
#Thumbprint extrahieren von $CA zur Überprüfung, ob es existiert.
$Thumbprint = (Get-PfxCertificate -FilePath $CA.FullName).Thumbprint


#Teste, ob Zertifikat mit GENAUEM THUMBPRINT bereits existiert. Wenn nicht installieren.
    if (Get-ChildItem -Path Cert:\LocalMachine\Root -Recurse | Where-Object {$_.Thumbprint -eq $Thumbprint}) {
        Write-Color -Text "`nRootCA bereits im Root LocalMachine Store enthalten!" -Color green
        Write-Color -Text "RootCA wird nicht importiert. Weiter zu SubCA`n" -Color green}
    else {
        Write-Color -Text "RootCA wurde nicht gefunden. Wird imporitert." -Color Red
        Import-Certificate -FilePath $CA.FullName -CertStoreLocation 'Cert:\LocalMachine\Root'
        Write-Color -Text "RootCA wurde importiert.`n" -Color Green
    }
}

#Suche die IntermediateCAs und importiere sie
$IntermediateCA = Get-ChildItem -Path $Temp | where-Object {$_.Name -like '*http*CA2*' -or $_.Name -like '*http*CA3*'}

ForEach ($CA in $IntermediateCA) {
#Thumbprint extrahieren von $CA zur Überprüfung, ob es existiert.
$Thumbprint = (Get-PfxCertificate -FilePath $CA.FullName).Thumbprint
$Cert_Name = (Get-PfxCertificate -FilePath $CA.FullName).SubjectName.Name

#Teste, ob Zertifikat mit GENAUEM THUMBPRINT bereits existiert. Wenn nicht installieren.
    if (Get-ChildItem -Path Cert:\LocalMachine\CA -Recurse | Where-Object {$_.Thumbprint -eq $Thumbprint}) {
        Write-Color -Text "$Cert_Name bereits im LocalMachine Store als subCA enthalten!" -Color green
        Write-Color "$Cert_Name wird nicht importiert.`n" -Color green}
    else {
        Write-Color "$Cert_Name wurde nicht gefunden. Wird imporitert." -Color Red
        Import-Certificate -FilePath $CA.FullName -CertStoreLocation 'Cert:\LocalMachine\CA'
        Write-Color "$Cert_Name wurde importiert.`n" -Color Green
    }
}

    #region Remove NRPT Key
    <#
    https://directaccess.richardhicks.com/2018/04/23/always-on-vpn-and-the-name-resolution-policy-table-nrpt/
    Our issue lies when we plug the machine back into the network (without reboot), the NRPT is still applying to the machine meaning we aren’t able to resolve any addresses in the NRPT with our internal DNS servers.
    Um dieses Problem zu umgehen müssen wir den Key DnsPolicyConfig entfernen.
    #>
    $NRPT_Path = 'HKLM:\Software\Policies\Microsoft\Windows NT\DNSClient\DnsPolicyConfig'
    $NRPT_Key = Test-Path $NRPT_Path
    if ($TRUE -eq $NRPT_Key){
        Remove-Item -Path $NRPT_Path -Force -Verbose
        Write-Host "NRPT-Key gelöscht. Tunnel kann genutzt werden."
        }
    else {
        Write-Host "NRPT-Key nicht vorhanden. Fahre fort."
        }
    #region endregion



#lösche den Temp-Ordner mit den Zertifikaten
Remove-Item $Temp -Recurse -Force;
